Var PreviousVersion

!macro CustomCodePreInstall
	${If} ${FileExists} "$INSTDIR\App\AppInfo\AppInfo.ini"
		ReadINIStr $PreviousVersion "$INSTDIR\App\AppInfo\appinfo.ini" "Version" "PackageVersion"
	${EndIf}
!macroend

!macro CustomCodePostInstall
; Pulled from PAL to cleanup leftover keys from pre-PAL not cleaning up Qt keys correctly
	
	; The Qt plugin cache and a few other things leave keys inside
	; HKCU\Software\Trolltech\OrganizationDefaults\*\X:\...\dirname which need
	; to be cleared up. They're useless, they've got just values like foo.dll
	; with a version number in them, but they need removing. Due to the
	; directory-recursive key nature of them, we can just scrap the package
	; directory for each and then prune the tree as far up as it's empty.
	${VersionCompare} "$PreviousVersion" "1.0.1.1" $1
	${If} $1 == "2"  ;$0 is older than
		StrCpy $R0 1
		${Do}
			ClearErrors
			ReadINIStr $0 "$INSTDIR\Other\Source\LightscreenPortablePrePALCleanup.ini" QtKeysCleanup $R0
			${IfThen} ${Errors} ${|} ${ExitDo} ${|}
			StrCpy $1 Software\Trolltech\OrganizationDefaults\$0\$INSTDIR\App
			DeleteRegKey HKCU $1
			${Do}
				${GetParent} $1 $1
				DeleteRegKey /ifempty HKCU $1
			${LoopUntil} $1 == "Software\Trolltech"

			IntOp $R0 $R0 + 1
		${Loop}
	; We don't need to set $UsesRegistry to true, the registry plug-in hasn't
	; been used and unloading it is what UsesRegistry is for.
	
		ReadINIStr $0 "$INSTDIR\Data\settings\lightscreen.ini" LastDirectory LastPath
		StrCpy $1 $0 2
		WriteINIStr "$INSTDIR\Data\settings\lightscreen.ini" LightscreenPortableSettings LastDrive $1
		DeleteINISec "$INSTDIR\Data\settings\lightscreen.ini" LastDirectory
		Rename "$INSTDIR\Data\settings\lightscreen.ini" "$INSTDIR\Data\settings\LightscreenPortableSettings.ini"
		Delete $INSTDIR\Data\settings\settings_readme.txt
	${EndIf}
		Delete $INSTDIR\Other\Source\LightScreenPortablePrePALCleanup.ini
!macroend